Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 24993)
@@ -68,6 +68,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		String to = service_name;
 		if (collection != null)
@@ -80,5 +79,5 @@
 			// we have been asked for the service description
 			Element mr_info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-			Element mr_info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, lang, uid);
+			Element mr_info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, userContext);
 			mr_info_message.appendChild(mr_info_request);
 
@@ -86,4 +85,5 @@
 			Element mr_info_response = (Element) this.mr.process(mr_info_message);
 			// the response
+			
 			Element service_response = (Element) GSXML.getChildByTagName(mr_info_response, GSXML.RESPONSE_ELEM);
 
@@ -96,5 +96,5 @@
 			// just a display request, no actual processing to do
 			//append site metadata
-			addSiteMetadata(page_response, lang, uid);
+			addSiteMetadata(page_response, userContext);
 			return page_response;
 		}
@@ -105,5 +105,5 @@
 		{ // no query
 			//append site metadata
-			addSiteMetadata(page_response, lang, uid);
+			addSiteMetadata(page_response, userContext);
 			return page_response;
 		}
@@ -111,5 +111,5 @@
 		// create the query request
 		Element mr_query_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		mr_query_message.appendChild(mr_query_request);
 
@@ -119,5 +119,5 @@
 
 		// also get the format stuff now if there is some
-		Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, to, lang, uid);
+		Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, to, userContext);
 		mr_query_message.appendChild(format_request);
 
@@ -131,5 +131,5 @@
 		{
 			//append site metadata
-			addSiteMetadata(page_response, lang, uid);
+			addSiteMetadata(page_response, userContext);
 			return page_response;
 		}
@@ -167,5 +167,5 @@
 			page_response.appendChild(this.doc.createElement(GSXML.DOC_NODE_ELEM + GSXML.LIST_MODIFIER));
 			//append site metadata
-			addSiteMetadata(page_response, lang, uid);
+			addSiteMetadata(page_response, userContext);
 			return page_response;
 		}
@@ -179,5 +179,5 @@
 			page_response.appendChild(this.doc.importNode(document_list, true));
 			//append site metadata
-			addSiteMetadata(page_response, lang, uid);
+			addSiteMetadata(page_response, userContext);
 			return page_response;
 		}
@@ -207,5 +207,5 @@
 			to = GSPath.prependLink(to, collection);
 		}
-		Element mr_metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element mr_metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		mr_metadata_message.appendChild(mr_metadata_request);
 
@@ -235,5 +235,5 @@
 		logger.debug("Query page:\n" + this.converter.getPrettyString(page_response));
 		//append site metadata
-		addSiteMetadata(page_response, lang, uid);
+		addSiteMetadata(page_response, userContext);
 		return page_response;
 	}
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java	(revision 24993)
@@ -11,5 +11,4 @@
 // other java stuff
 import java.io.File;
-import java.util.HashMap;
 import java.util.*;
 import java.io.StringReader;
@@ -46,6 +45,5 @@
 
 		String subaction = request.getAttribute(GSXML.SUBACTION_ATT);
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		// get the param list
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
@@ -63,5 +61,5 @@
 
 		Element mr_request_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element mr_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_SYSTEM, to, lang, uid);
+		Element mr_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_SYSTEM, to, userContext);
 		mr_request_message.appendChild(mr_request);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java	(revision 24993)
@@ -52,6 +52,5 @@
 			return result;
 		}
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// subaction used to decide if we are returning content or structure
@@ -74,5 +73,5 @@
 		Element mr_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
 
-		Element ret_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element ret_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		mr_message.appendChild(ret_request);
 
@@ -85,5 +84,5 @@
 		// also add in a request for the Title metadata
 		to = GSPath.appendLink(collection, "DocumentMetadataRetrieve");
-		Element meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		// copy the doc list
 		meta_request.appendChild(doc_list.cloneNode(true));
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/ServiceCluster.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/ServiceCluster.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/ServiceCluster.java	(revision 24993)
@@ -347,5 +347,5 @@
 			// services it provides
 			Element message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-			Element request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", "", "");
+			Element request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", new UserContext());
 			message.appendChild(request);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/DefaultReceptionist.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/DefaultReceptionist.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/DefaultReceptionist.java	(revision 24993)
@@ -55,6 +55,5 @@
 		// see if the collection/cluster element is already there
 		String coll_name = coll_param.getAttribute(GSXML.VALUE_ATT);
-		String lang = page_request.getAttribute(GSXML.LANG_ATT);
-		String uid = page_request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(page_request);
 
 		if (coll_name.equals(""))
@@ -84,5 +83,5 @@
 			// we dont have one yet - get it
 			Element coll_about_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-			Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, coll_name, lang, uid);
+			Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, coll_name, userContext);
 			coll_about_message.appendChild(coll_about_request);
 
@@ -158,5 +157,5 @@
 			String name = c.getAttribute(GSXML.NAME_ATT);
 			String address = GSPath.appendLink(coll_name, name);
-			Element info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, address, lang, uid);
+			Element info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, address, userContext);
 			//Element req_param_list = this.doc.createElement(GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
 			//req_param_list.appendChild(GSXML.createParameter(this.doc, GSXML.SUBSET_PARAM, GSXML.DISPLAY_TEXT_ELEM+GSXML.LIST_MODIFIER));
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 24993)
@@ -454,5 +454,5 @@
     
     Element service_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-    Element service_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", "", "");
+    Element service_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", new UserContext());
     service_message.appendChild(service_request);
     
@@ -774,5 +774,5 @@
     
     Element info_request = this.doc.createElement(GSXML.MESSAGE_ELEM);
-    Element req = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", "", "");
+    Element req = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", new UserContext());
     info_request.appendChild(req);
     
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java	(revision 24993)
@@ -763,5 +763,5 @@
 		//Transformation of the XML message from the receptionist to HTML with doctype
 
-		if(inlineTemplate != null)
+		if (inlineTemplate != null)
 		{
 			try
@@ -770,13 +770,13 @@
 				GSXSLT.mergeStylesheets(skinAndLibraryDoc, inlineTemplateDoc.getDocumentElement());
 			}
-			catch(Exception ex)
+			catch (Exception ex)
 			{
 				ex.printStackTrace();
 			}
 		}
-		
+
 		if (skinAndLibraryDoc.getElementsByTagName("gsf:metadata").getLength() > 0)
 		{
-			secondConfigFormatPass(collection, skinAndLibraryDoc, doc, request.getAttribute("lang"), request.getAttribute("uid"));
+			secondConfigFormatPass(collection, skinAndLibraryDoc, doc, new UserContext(request));
 		}
 
@@ -795,9 +795,9 @@
 	}
 
-	protected void secondConfigFormatPass(String collection, Document skinAndLibraryDoc, Document doc, String lang, String uid)
+	protected void secondConfigFormatPass(String collection, Document skinAndLibraryDoc, Document doc, UserContext userContext)
 	{
 		String to = GSPath.appendLink(collection, "DocumentMetadataRetrieve"); // Hard-wired?
 		Element metaMessage = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element metaRequest = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element metaRequest = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		Element paramList = this.doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
 		Element docNodeList = this.doc.createElement(GSXML.DOC_NODE_ELEM + GSXML.LIST_MODIFIER);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveIO.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveIO.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveIO.java	(revision 24993)
@@ -28,4 +28,5 @@
 import org.greenstone.gsdl3.util.GSXML;
 import org.greenstone.gsdl3.util.SimpleCollectionDatabase;
+import org.greenstone.gsdl3.util.UserContext;
 
 import org.w3c.dom.Element;
@@ -108,6 +109,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// Get the parameters of the request
@@ -123,5 +123,5 @@
 		String collection = (String) params.get(GSXML.COLLECTION_ATT);
 
-		String filePath = _GSDM.archiveGetDocumentFilePath(oid, collection, lang, uid);
+		String filePath = _GSDM.archiveGetDocumentFilePath(oid, collection, userContext);
 		
 		Element metadataList = this.doc.createElement(GSXML.METADATA_ELEM + GSXML.LIST_MODIFIER);
@@ -139,6 +139,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// Get the parameters of the request
@@ -154,5 +153,5 @@
 		String collection = (String) params.get(GSXML.COLLECTION_ATT);
 
-		String oid = _GSDM.archiveGetSourceFileOID(srcFile, collection, lang, uid);
+		String oid = _GSDM.archiveGetSourceFileOID(srcFile, collection, userContext);
 		if(_GSDM.checkError(result, ARCHIVE_GET_SOURCE_FILE_OID))
 		{
@@ -174,6 +173,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// Get the parameters of the request
@@ -189,5 +187,5 @@
 		String collection = (String) params.get(GSXML.COLLECTION_ATT);
 		
-		boolean exists = _GSDM.archiveCheckDocumentOrSectionExists(oid, collection, lang, uid);
+		boolean exists = _GSDM.archiveCheckDocumentOrSectionExists(oid, collection, userContext);
 		if(_GSDM.checkError(result, ARCHIVE_CHECK_DOCUMENT_OR_SECTION_EXISTS))
 		{
@@ -207,6 +205,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// Get the parameters of the request
@@ -255,5 +252,5 @@
 		}
 		
-		_GSDM.archiveWriteEntryToDatabase(oid, collection, info, lang, uid);
+		_GSDM.archiveWriteEntryToDatabase(oid, collection, info, userContext);
 		_GSDM.checkError(result, ARCHIVE_WRITE_ENTRY_TO_DATABASE);
 
@@ -268,6 +265,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// Get the parameters of the request
@@ -299,5 +295,5 @@
 		}
 		
-		_GSDM.archiveRemoveEntryFromDatabase(oid, collection, lang, uid);
+		_GSDM.archiveRemoveEntryFromDatabase(oid, collection, userContext);
 		_GSDM.checkError(result, ARCHIVE_REMOVE_ENTRY_FROM_DATABASE);
 
@@ -312,6 +308,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// Get the parameters of the request
@@ -327,5 +322,5 @@
 		String collection = (String) params.get(GSXML.COLLECTION_ATT);
 
-		ArrayList<String> assocFiles = _GSDM.archiveGetAssociatedImportFiles(oid, collection, lang, uid);
+		ArrayList<String> assocFiles = _GSDM.archiveGetAssociatedImportFiles(oid, collection, userContext);
 		if(_GSDM.checkError(result, ARCHIVE_GET_ASSOCIATED_IMPORT_FILES))
 		{
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveRetrieve.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveRetrieve.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/ArchiveRetrieve.java	(revision 24993)
@@ -25,4 +25,5 @@
 import org.greenstone.gsdl3.util.GSXML;
 import org.greenstone.gsdl3.util.SimpleCollectionDatabase;
+import org.greenstone.gsdl3.util.UserContext;
 
 import org.w3c.dom.Element; 
@@ -106,6 +107,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 		
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		
 		// Get the parameters of the request
@@ -120,5 +120,5 @@
 		String collection = (String) params.get("c");
 		
-		String assocFilePath = getAssocFilePathFromDocID(oid, collection, lang, uid);
+		String assocFilePath = getAssocFilePathFromDocID(oid, collection, userContext);
 		
 		String docFilePath = this.site_home + File.separatorChar + 
@@ -143,6 +143,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 		
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		
 		// Get the parameters of the request
@@ -159,5 +158,5 @@
 		
 		//Find out what kind of database we have
-		String databaseType = getDatabaseTypeFromCollection(collection, lang, uid);
+		String databaseType = getDatabaseTypeFromCollection(collection, userContext);
 		if (databaseType == null || databaseType.equals("")) 
 		{
@@ -215,6 +214,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 		
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		
 		// Get the parameters of the request
@@ -230,5 +228,5 @@
 		String collection = (String) params.get("c");
 		
-		String databaseType = getDatabaseTypeFromCollection(collection, lang, uid);
+		String databaseType = getDatabaseTypeFromCollection(collection, userContext);
 		if (databaseType == null || databaseType.equals("")) 
 		{
@@ -294,8 +292,8 @@
 	}
 	
-	public String getAssocFilePathFromDocID(String oid, String collection, String lang, String uid)
+	public String getAssocFilePathFromDocID(String oid, String collection, UserContext userContext)
 	{
 		Element mr_query_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element mr_query_request = GSXML.createBasicRequest (this.doc, GSXML.REQUEST_TYPE_PAGE, collection + "/DocumentMetadataRetrieve", lang, uid);
+		Element mr_query_request = GSXML.createBasicRequest (this.doc, GSXML.REQUEST_TYPE_PAGE, collection + "/DocumentMetadataRetrieve", userContext);
 		mr_query_message.appendChild(mr_query_request);
 		
@@ -322,9 +320,9 @@
 	}
 	
-	public String getDatabaseTypeFromCollection(String collection, String lang, String uid)
+	public String getDatabaseTypeFromCollection(String collection, UserContext userContext)
 	{
 		//Find out what kind of database we have
 		Element dbTypeMessage = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element dbTypeRequest = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, collection, lang, uid);
+		Element dbTypeRequest = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, collection, userContext);
 		dbTypeMessage.appendChild(dbTypeRequest);
 		Element dbTypeResponse = (Element)this.router.process(dbTypeMessage);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java	(revision 24993)
@@ -33,4 +33,5 @@
 import org.greenstone.gsdl3.util.GSXML;
 import org.greenstone.gsdl3.util.GSPath;
+import org.greenstone.gsdl3.util.UserContext;
 
 import java.net.InetAddress;
@@ -262,5 +263,9 @@
 		ArrayList tmp = new ArrayList();
 		tmp.add(id);
-		Element response = getDocumentMetadata(to, "en", "dumy", tmp.iterator());
+		
+		UserContext userContext = new UserContext();
+		userContext.setLanguage("en");
+		userContext.setUserID("dumy");
+		Element response = getDocumentMetadata(to, userContext, tmp.iterator());
 		Element doc_node = (Element) response.getElementsByTagName(GSXML.DOC_NODE_ELEM).item(0);
 
@@ -432,10 +437,10 @@
 	}
 
-	private Element getDocumentMetadata(String to, String lang, String uid, Iterator ids)
+	private Element getDocumentMetadata(String to, UserContext userContext, Iterator ids)
 	{
 
 		// Build a request to obtain some document metadata
 		Element dm_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element dm_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element dm_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		dm_message.appendChild(dm_request);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CrossCollectionSearch.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CrossCollectionSearch.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/CrossCollectionSearch.java	(revision 24993)
@@ -21,4 +21,5 @@
 import org.greenstone.gsdl3.util.GSXML;
 import org.greenstone.gsdl3.util.GSPath;
+import org.greenstone.gsdl3.util.UserContext;
 
 import org.w3c.dom.Element;
@@ -147,5 +148,6 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
+		UserContext userContext = new UserContext(request);
+		
 		// Get the parameters of the request
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
@@ -182,5 +184,5 @@
 		}
 		// send the query to all colls
-		Element query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to_att.toString(), lang, "");
+		Element query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to_att.toString(), userContext);
 		query_message.appendChild(query_request);
 		// should we add params individually?
@@ -257,9 +259,11 @@
 	protected boolean initCollectionList()
 	{
-		String lang = "en";
-		String uid = "";
+		UserContext userContext = new UserContext();
+		userContext.setLanguage("en");
+		userContext.setUserID("");
+
 		// first, get the message router info
 		Element coll_list_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element coll_list_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", lang, ""); // uid
+		Element coll_list_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", userContext); // uid
 		coll_list_message.appendChild(coll_list_request);
 		logger.debug("coll list request = " + this.converter.getPrettyString(coll_list_request));
@@ -281,5 +285,5 @@
 			Element c = (Element) colls.item(i);
 			String name = c.getAttribute(GSXML.NAME_ATT);
-			Element metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, name, lang, uid);
+			Element metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, name, userContext);
 			metadata_message.appendChild(metadata_request);
 		}
@@ -331,5 +335,5 @@
 		result.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
+		UserContext userContext = new UserContext(request);
 		// Get the parameters of the request
 		Element param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
@@ -382,5 +386,5 @@
 			String cname = (String) e.getKey();
 			Element doc_nodes = (Element) e.getValue();
-			Element meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, GSPath.appendLink(cname, DOCUMENT_METADATA_RETRIEVE_SERVICE), lang, "");
+			Element meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, GSPath.appendLink(cname, DOCUMENT_METADATA_RETRIEVE_SERVICE), userContext);
 			meta_request.appendChild(doc_nodes);
 			meta_request.appendChild(new_param_list.cloneNode(true));
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocXMLUtil.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocXMLUtil.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocXMLUtil.java	(revision 24993)
@@ -24,4 +24,5 @@
 import org.greenstone.gsdl3.util.GSPath;
 import org.greenstone.gsdl3.util.GSXML;
+import org.greenstone.gsdl3.util.UserContext;
 
 import org.w3c.dom.Document;
@@ -122,6 +123,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the document items that are requested
@@ -133,5 +133,5 @@
 			String collection = currentDoc.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentXMLCreateDocXML(oid, collection, lang, uid);
+			_GSDM.documentXMLCreateDocXML(oid, collection, userContext);
 			if(_GSDM.checkError(result, DOC_XML_CREATE_EMPTY_FILE))
 			{
@@ -152,6 +152,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the metadata items that are requested
@@ -164,5 +163,5 @@
 			String metadataName = currentMetadata.getAttribute(GSXML.NAME_ATT);
 
-			ArrayList<Element> metadataValues = _GSDM.documentXMLGetMetadata(oid, collection, metadataName, lang, uid);
+			ArrayList<Element> metadataValues = _GSDM.documentXMLGetMetadata(oid, collection, metadataName, userContext);
 			if(_GSDM.checkError(result, DOC_XML_GET_METADATA))
 			{
@@ -192,6 +191,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the metadata items that are requested
@@ -237,5 +235,5 @@
 					return result;
 				}
-				_GSDM.documentXMLSetMetadata(oid, collection, metadataName, newMetadataValue, pos, op, lang, uid);
+				_GSDM.documentXMLSetMetadata(oid, collection, metadataName, newMetadataValue, pos, op, userContext);
 				if(_GSDM.checkError(result, DOC_XML_SET_METADATA))
 				{
@@ -246,5 +244,5 @@
 			else if (oldMetadataValue != null && !oldMetadataValue.equals(""))
 			{
-				_GSDM.documentXMLReplaceMetadata(oid, collection, metadataName, oldMetadataValue, newMetadataValue, lang, uid);
+				_GSDM.documentXMLReplaceMetadata(oid, collection, metadataName, oldMetadataValue, newMetadataValue, userContext);
 				if(_GSDM.checkError(result, DOC_XML_SET_METADATA))
 				{
@@ -272,6 +270,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the requests 
@@ -283,5 +280,5 @@
 			String collection = currentSection.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentXMLCreateSection(oid, collection, lang, uid);
+			_GSDM.documentXMLCreateSection(oid, collection, userContext);
 			if(_GSDM.checkError(result, DOC_XML_CREATE_SECTION))
 			{
@@ -302,6 +299,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the requests 
@@ -313,5 +309,5 @@
 			String collection = currentSection.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentXMLDeleteSection(oid, collection, lang, uid);
+			_GSDM.documentXMLDeleteSection(oid, collection, userContext);
 			if(_GSDM.checkError(result, DOC_XML_DELETE_SECTION))
 			{
@@ -332,6 +328,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the requests 
@@ -343,5 +338,5 @@
 			String collection = currentSection.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentXMLGetSection(oid, collection, lang, uid);
+			_GSDM.documentXMLGetSection(oid, collection, userContext);
 			if(_GSDM.checkError(result, DOC_XML_GET_SECTION))
 			{
@@ -362,6 +357,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the requests 
@@ -388,5 +382,5 @@
 			}
 			
-			_GSDM.documentXMLSetSection(oid, collection, currentSection, op, lang, uid);
+			_GSDM.documentXMLSetSection(oid, collection, currentSection, op, userContext);
 			if(_GSDM.checkError(result, DOC_XML_SET_SECTION))
 			{
@@ -408,6 +402,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the requests 
@@ -419,5 +412,5 @@
 			String collection = currentContent.getAttribute(GSXML.COLLECTION_ATT);
 
-			String content = _GSDM.documentXMLGetText(oid, collection, lang, uid);
+			String content = _GSDM.documentXMLGetText(oid, collection, userContext);
 			if(_GSDM.checkError(result, DOC_XML_GET_TEXT))
 			{
@@ -451,6 +444,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		//Go through each of the requests 
@@ -462,5 +454,5 @@
 			String collection = currentContent.getAttribute(GSXML.COLLECTION_ATT);
 
-			_GSDM.documentXMLSetText(oid, collection, currentContent, lang, uid);
+			_GSDM.documentXMLSetText(oid, collection, currentContent, userContext);
 			if(_GSDM.checkError(result, DOC_XML_SET_TEXT))
 			{
